import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;

public class Midlet extends MIDlet
{
    public Display dp;
    public void startApp(){
        (dp = Display.getDisplay(this)).setCurrent(new Canvaz(this));
    }
    public void pauseApp(){
    }
    public void destroyApp(boolean b) {
    }
}

class Canvaz extends Canvas
{
    final String path = "file:///e:/decode/test.png";
    Image image;
    //bạn có thể sửa thành thư mục trong thẻ nhớ e:/
    
    Midlet main;
    
    Canvaz(Midlet main)
    {
        this.main = main;
        image = ac.e("/walk");
    }
    public void paint(Graphics g){
        g.drawImage(image, 10, 10, 0);
    }
    
        byte[][] argb(Image img) {
        int[] pixels = new int[img.getWidth() * img.getHeight()];
        img.getRGB(pixels, 0, img.getWidth(), 0, 0, img.getWidth(),
        img.getHeight());
        
        // separate channels
        byte[] red = new byte[pixels.length];
        byte[] green = new byte[pixels.length];
        byte[] blue = new byte[pixels.length];
        byte[] alpha = new byte[pixels.length];
        for (int i = 0; i < pixels.length; i++) {
            int argb = pixels[i];
            //binary operations to separate the channels
            //alpha is the left most byte of the int (0xAARRGGBB)
            alpha[i] = (byte) (argb >> 24);
            red[i] = (byte) (argb >> 16);
            green[i] = (byte) (argb >> 8);
            blue[i] = (byte) (argb);
        }
        return new byte[][]{alpha, red, green, blue};
    }
    
    Image  getScreenShot(){
        Image   screenshot = Image . createImage(getWidth(),   getHeight());
        Graphics   g  =   screenshot . getGraphics();
        paint(g);
        return Image . createImage(screenshot);
    }
    
    public void keyPressed(int k){
        Image im = image;
        savePNG(im);
    }
    
    void savePNG(Image im){
        try{
            FileConnection fc = (FileConnection) Connector.open(path);
            if(!fc.exists()) {
                fc.create();
            }
            else {
                fc.delete();
                fc.create();
            }
            
            OutputStream os = fc.openOutputStream();
            byte[][] argb = argb(im);
            byte[] pngdata = PNG.toPNG(im.getWidth(), im.getHeight(), argb[0], argb[1], argb[2], argb[3]);
            os.write(pngdata);
            os.close();
            fc.close();
            main.dp.setCurrent(new Alert("thông báo", "đã lưu!", null, AlertType.CONFIRMATION), this);
        }
        catch(Exception e){
        }
        
    }
    
}

